xquery version "3.1";

module namespace kmg-util="http://mollenhauer-edition.de/ns/util";

import module namespace config="https://sade.textgrid.de/ns/config" at "../config.xqm";
import module namespace functx="http://www.functx.com";

declare namespace tei="http://www.tei-c.org/ns/1.0";
declare namespace html="http://www.w3.org/1999/xhtml";
declare namespace tg="http://textgrid.info/namespaces/metadata/core/2010";

declare variable $kmg-util:Mapping :=
<mapping>
    <text kmg="112" tguri="41zm9"/>
    <text kmg="034" tguri="3vwqn"/>
    <text kmg="039" tguri="3xsz9"/>
    <text kmg="067" tguri="3qqpr"/>
    <text kmg="115" tguri="3xrpk"/>
    <text kmg="221" tguri="412jg"/>
    <text kmg="192" tguri="3qqrq"/>
    <text kmg="224" tguri="41rp3"/>
    <text kmg="174" tguri="3w1mp"/>
    <text kmg="091" tguri="3qqpd"/>
    <text kmg="090" tguri="3qqpg"/>
    <text kmg="078" tguri="3xwt8"/>
    <text kmg="094" tguri="3qqmg"/>
    <text kmg="119" tguri="3qqk9"/>
    <text kmg="154" tguri="3qqj8"/>
    <text kmg="220" tguri="3qqj8"/>
    <text kmg="E01" tguri="3q2ff"/>
    <text kmg="E08" tguri="3q71r"/>
    <text kmg="E03" tguri="3q4rs"/>
    <text kmg="E04" tguri="3q4rt"/>
    <text kmg="E05" tguri="3q4rw"/>
    <text kmg="E06" tguri="3q6sw"/>
    <text kmg="E07" tguri="3q6sx"/>
    <text kmg="E02" tguri="3q3xw"/>
    <text kmg="247" tguri="420ds"/>
    <text kmg="248" tguri="420dt"/>
    <text kmg="005" tguri="3qqvh"/>
    <text kmg="008" tguri="3qqv2"/>
    <text kmg="020" tguri="40rjg"/>
    <text kmg="024" tguri="3wnw1"/>
    <text kmg="026" tguri="3qqsg"/>
    <text kmg="227" tguri="41pwq"/>
    <text kmg="228" tguri="41pwr"/>
    <text kmg="229" tguri="41pws"/>
    <text kmg="230" tguri="41pwt"/>
    <text kmg="231" tguri="41pwv"/>
    <text kmg="232" tguri="41pww"/>
    <text kmg="233" tguri="41pwx"/>
    <text kmg="234" tguri="41pwz"/>
    <text kmg="029" tguri="3qqs2"/>
    <text kmg="042" tguri="3qqr9"/>
    <text kmg="047" tguri="3qqqt"/>
    <text kmg="048" tguri="3qqqz"/>
    <text kmg="054" tguri="3qqqw"/>
    <text kmg="236" tguri="41s2c"/>
    <text kmg="E09" tguri="41s2g"/>
    <text kmg="055" tguri="3qqqr"/>
    <text kmg="226" tguri="41nsv"/>
    <text kmg="063" tguri="3qqqj"/>
    <text kmg="059" tguri="3qqqb"/>
    <text kmg="057" tguri="40znj"/>
    <text kmg="E10" tguri="3qqpm"/>
    <text kmg="064" tguri="3qqq1"/>
    <text kmg="E39" tguri="4209p"/>
    <text kmg="E40" tguri="4209q"/>
    <text kmg="E41" tguri="4209r"/>
    <text kmg="071" tguri="3qqp4"/>
    <text kmg="072" tguri="3qqp6"/>
    <text kmg="080" tguri="3qqnk"/>
    <text kmg="081" tguri="3qqnh"/>
    <text kmg="082" tguri="3qqnf"/>
    <text kmg="083" tguri="3qqnc"/>
    <text kmg="084" tguri="3qqn9"/>
    <text kmg="085" tguri="3qqns"/>
    <text kmg="238" tguri="41rc2"/>
    <text kmg="235" tguri="41r03"/>
    <text kmg="096" tguri="3qqmd"/>
    <text kmg="102" tguri="3qqm4"/>
    <text kmg="103" tguri="3qqm8"/>
    <text kmg="106" tguri="3qqm0"/>
    <text kmg="105" tguri="3qqm6"/>
    <text kmg="109" tguri="416gd"/>
    <text kmg="117" tguri="3qqkn"/>
    <text kmg="120" tguri="3qqm0"/>
    <text kmg="123" tguri="3qqjt"/>
    <text kmg="131" tguri="3qqjb"/>
    <text kmg="136" tguri="3qqhx"/>
    <text kmg="140" tguri="3qqhf"/>
    <text kmg="141" tguri="3qqn3"/>
    <text kmg="223" tguri="3qqhq"/>
    <text kmg="139" tguri="3qqhq"/>
    <text kmg="149" tguri="3qqgt"/>
    <text kmg="150" tguri="3qqc3"/>
    <text kmg="163" tguri="3qqfs"/>
    <text kmg="164" tguri="3qqfq"/>
    <text kmg="165" tguri="3qqfn"/>
    <text kmg="166" tguri="3qqfk"/>
    <text kmg="172" tguri="3qqf1"/>
    <text kmg="182" tguri="3qqc3"/>
    <text kmg="186" tguri="3qqd0"/>
    <text kmg="196" tguri="3qqcx"/>
    <text kmg="190" tguri="3qqcf"/>
    <text kmg="198" tguri="3qqc9"/>
    <text kmg="203" tguri="3qqc3"/>
    <text kmg="205" tguri="3qqbt"/>
    <text kmg="211" tguri="3qqbd"/>
    <text kmg="215" tguri="3qqb4"/>
    <text kmg="216" tguri="3qqb8"/>
    <text kmg="217" tguri="3qqb6"/>
    <text kmg="218" tguri="3qqb2"/>
    <text kmg="219" tguri="3qqb0"/>
    <text kmg="222" tguri="3qqg6"/>
    <text kmg="001" tguri="3wjxj"/>
    <text kmg="002" tguri="3qqvk"/>
    <text kmg="003" tguri="3wjz3"/>
    <text kmg="004" tguri="3qqv4"/>
    <text kmg="006" tguri="3qqvc"/>
    <text kmg="007" tguri="3qqv0"/>
    <text kmg="009" tguri="3wk0s"/>
    <text kmg="010" tguri="3qqtx"/>
    <text kmg="011" tguri="3qqtv"/>
    <text kmg="012" tguri="3qqtn"/>
    <text kmg="013" tguri="3qqtk"/>
    <text kmg="014" tguri="3w5gj"/>
    <text kmg="015" tguri="3qqsz"/>
    <text kmg="016" tguri="3qqsw"/>
    <text kmg="017" tguri="3qqt3"/>
    <text kmg="018" tguri="3qqt1"/>
    <text kmg="019" tguri="3w4vq"/>
    <text kmg="021" tguri="3qqsr"/>
    <text kmg="022" tguri="3qqsp"/>
    <text kmg="023" tguri="3qqsm"/>
    <text kmg="025" tguri="3qqsj"/>
    <text kmg="027" tguri="3qqsd"/>
    <text kmg="028" tguri="3qqsb"/>
    <text kmg="030" tguri="3qqs4"/>
    <text kmg="031" tguri="3qqs8"/>
    <text kmg="032" tguri="3qqs6"/>
    <text kmg="033" tguri="3qqrx"/>
    <text kmg="036" tguri="3qqrv"/>
    <text kmg="038" tguri="3qqrk"/>
    <text kmg="040" tguri="3qqrh"/>
    <text kmg="043" tguri="3qqrc"/>
    <text kmg="041" tguri="3qqrf"/>
    <text kmg="035" tguri="40pvh"/>
    <text kmg="037" tguri="3qqr5"/>
    <text kmg="049" tguri="3w4w6"/>
    <text kmg="045" tguri="3qqr3"/>
    <text kmg="044" tguri="3qqr7"/>
    <text kmg="046" tguri="3w493"/>
    <text kmg="050" tguri="3qqr1"/>
    <text kmg="051" tguri="3wpk6"/>
    <text kmg="052" tguri="3qqqp"/>
    <text kmg="053" tguri="3qqq3"/>
    <text kmg="225" tguri="41mgp"/>
    <text kmg="056" tguri="3qqqm"/>
    <text kmg="058" tguri="3qqqg"/>
    <text kmg="060" tguri="3qqqd"/>
    <text kmg="062" tguri="3qqq8"/>
    <text kmg="061" tguri="3qqpz"/>
    <text kmg="065" tguri="3qqpw"/>
    <text kmg="066" tguri="3qqpt"/>
    <text kmg="073" tguri="3qqpp"/>
    <text kmg="068" tguri="3qqpj"/>
    <text kmg="069" tguri="3qqpb"/>
    <text kmg="070" tguri="3qqp8"/>
    <text kmg="074" tguri="3qqp2"/>
    <text kmg="075" tguri="3qqp0"/>
    <text kmg="076" tguri="3qqnx"/>
    <text kmg="087" tguri="3qqnv"/>
    <text kmg="077" tguri="3qqnq"/>
    <text kmg="079" tguri="3qqnn"/>
    <text kmg="086" tguri="3qqn7"/>
    <text kmg="088" tguri="3qqn5"/>
    <text kmg="089" tguri="3qqn1"/>
    <text kmg="092" tguri="3qqmz"/>
    <text kmg="093" tguri="3qqmm"/>
    <text kmg="095" tguri="3qqmj"/>
    <text kmg="101" tguri="3qqmb"/>
    <text kmg="097" tguri="3qqmw"/>
    <text kmg="098" tguri="3qqmt"/>
    <text kmg="099" tguri="3qqmr"/>
    <text kmg="100" tguri="3qqmp"/>
    <text kmg="104" tguri="3qqm2"/>
    <text kmg="107" tguri="3qqkx"/>
    <text kmg="108" tguri="3qqkv"/>
    <text kmg="110" tguri="3qqks"/>
    <text kmg="111" tguri="3qqkq"/>
    <text kmg="113" tguri="3qqkk"/>
    <text kmg="114" tguri="3qqkh"/>
    <text kmg="116" tguri="3qqkf"/>
    <text kmg="118" tguri="3qqkc"/>
    <text kmg="121" tguri="3qqjz"/>
    <text kmg="122" tguri="3qqjw"/>
    <text kmg="124" tguri="3wk0w"/>
    <text kmg="125" tguri="3qqjr"/>
    <text kmg="126" tguri="3qqjp"/>
    <text kmg="127" tguri="3qqjm"/>
    <text kmg="128" tguri="3qqjj"/>
    <text kmg="129" tguri="3qqjg"/>
    <text kmg="130" tguri="3qqjd"/>
    <text kmg="132" tguri="3qqj8"/>
    <text kmg="133" tguri="3qqj4"/>
    <text kmg="134" tguri="3qqj2"/>
    <text kmg="135" tguri="3qqj0"/>
    <text kmg="137" tguri="3qqhv"/>
    <text kmg="138" tguri="3qqhs"/>
    <text kmg="142" tguri="3qqhh"/>
    <text kmg="143" tguri="3qqhc"/>
    <text kmg="144" tguri="3qqh9"/>
    <text kmg="145" tguri="3qqh7"/>
    <text kmg="146" tguri="3qqh5"/>
    <text kmg="147" tguri="3qqgz"/>
    <text kmg="148" tguri="3qqgw"/>
    <text kmg="151" tguri="3qqgp"/>
    <text kmg="152" tguri="3qqgr"/>
    <text kmg="153" tguri="3qqgj"/>
    <text kmg="155" tguri="3qqgg"/>
    <text kmg="156" tguri="3qqfv"/>
    <text kmg="157" tguri="3qqgd"/>
    <text kmg="158" tguri="3qqg8"/>
    <text kmg="159" tguri="3qqg4"/>
    <text kmg="160" tguri="3qqg2"/>
    <text kmg="161" tguri="3qqg0"/>
    <text kmg="162" tguri="3qqfx"/>
    <text kmg="167" tguri="3qqfh"/>
    <text kmg="168" tguri="3qqff"/>
    <text kmg="169" tguri="3qqf9"/>
    <text kmg="170" tguri="3qqf7"/>
    <text kmg="171" tguri="3qqf5"/>
    <text kmg="173" tguri="3qqdm"/>
    <text kmg="175" tguri="3qqf3"/>
    <text kmg="176" tguri="3qqdz"/>
    <text kmg="177" tguri="3qqdw"/>
    <text kmg="178" tguri="3qqdt"/>
    <text kmg="179" tguri="3qqdr"/>
    <text kmg="180" tguri="3qqdj"/>
    <text kmg="181" tguri="3qqdg"/>
    <text kmg="183" tguri="3qqdd"/>
    <text kmg="184" tguri="3qqdb"/>
    <text kmg="185" tguri="3qqd2"/>
    <text kmg="187" tguri="3qqd6"/>
    <text kmg="188" tguri="3qqd4"/>
    <text kmg="189" tguri="3qqd2"/>
    <text kmg="191" tguri="3qqcv"/>
    <text kmg="193" tguri="3qqcs"/>
    <text kmg="194" tguri="3qqch"/>
    <text kmg="197" tguri="3qqcn"/>
    <text kmg="195" tguri="3qqck"/>
    <text kmg="208" tguri="3qqcc"/>
    <text kmg="199" tguri="3qqc7"/>
    <text kmg="200" tguri="3qqc5"/>
    <text kmg="201" tguri="3qqc3"/>
    <text kmg="202" tguri="3qqc1"/>
    <text kmg="206" tguri="3qqbz"/>
    <text kmg="204" tguri="3qqbw"/>
    <text kmg="207" tguri="3qqbr"/>
    <text kmg="213" tguri="3qqcn"/>
    <text kmg="214" tguri="3qqbp"/>
    <text kmg="209" tguri="3qqbm"/>
    <text kmg="210" tguri="3qqbj"/>
    <text kmg="212" tguri="3qqbb"/>
</mapping>;

(:~
 : This function reads the tei:header of the corresponding file and identifies all witness IDs.
 :
 : @param $filename e.g. "2228v.xml"
 : @return A xs:string sequence that contains all witnesses of the tei:header.
 :)
declare function kmg-util:getWitnessIDs($filename as xs:string) as xs:string* {
    let $doc := doc($config:sade-data || $filename)

    let $listWitIDs := $doc//tei:teiHeader/tei:fileDesc/tei:sourceDesc/tei:listWit/tei:witness/@xml:id/string()
    let $listWit := ()
    let $listWit :=
        for $id in $listWitIDs return
            fn:insert-before($listWit, last(), $id)

    return $listWit
};

declare function kmg-util:count-witnesses($filename as xs:string) {
    let $doc := doc($config:sade-data || $filename || (if (matches($filename, ".xml")) then "" else ".xml"))

    return
        count($doc//tei:witness)
};

(:~
 : This function reads the tei:header of the corresponding file and identifies the 'Leittext' witness.
 :
 : @param $filename e.g. "2228v.xml"
 : @return A xs:string that contains the of the 'Leittext' witness.
 :)
declare function kmg-util:getLeittextID($filename as xs:string) as xs:string {
    let $doc := doc($config:sade-data || $filename)

    let $witLeittext :=
        try {
            $doc//tei:teiHeader/tei:fileDesc/tei:sourceDesc/tei:listWit/tei:witness/tei:desc[contains(@type, 'Leittext')]/../@xml:id/string()
        }
        catch * {
            util:log-system-out(util:system-time() || " " || $filename || ": Error: Could not identify witness with 'Leittext'.")
        }

    return $witLeittext
};

(:~
 : Creates the correct kind of quotation marks around a quote
 :
 : @param $rend A string containing the attribute value of the node that is being transformed
 : @param $filename E.g. "1234v.xml"
 : @param $mode The edition or utility view being transformed
 : @return A quotation
 :)
declare function kmg-util:quote-marks(
    $rend as xs:string, $filename as xs:string, $mode as xs:string)
{
    let $doc := doc($config:sade-data || $filename || (if (matches($filename, ".xml")) then "" else ".xml"))
    (: let $doc := doc($config:aux || "editions.xml") :)
    let $quote-marks :=
        map {
            "g_out": map {
                "single": map {
                    "open": "‹",
                    "close": "›"
                },
                "double": map {
                    "open": "«",
                    "close": "»"
                }
            },
            "g_in": map {
                "single": map {
                    "open": "›",
                    "close": "‹"
                },
                "double": map {
                    "open": "»",
                    "close": "«"
                }
            },
            "qm_high": map {
                "single": map {
                    "open": "‘",
                    "close": "’"
                },
                "double": map {
                    "open": "“",
                    "close": "”"
                }
            },
            "qm_low": map {
                "single": map {
                    "open": "‚",
                    "close": "‘"
                },
                "double": map {
                    "open": "„",
                    "close": "“"
                }
            }
        }
    let $global-rend-att :=
        if ($mode = "digital" or $mode = "commentary" or $mode = "none") then
            string($doc//tei:witness[tei:desc[contains(@type, "Leittext")]]/@rend)
        else
            string($doc//tei:witness[@xml:id = $mode]/@rend)
    let $rend-att :=
        if ($global-rend-att) then
            $global-rend-att
        else
            $rend
    let $quote-mark :=
        if (contains($rend-att, "g_out")) then
            "g_out"
        else if (contains($rend-att, "g_in")) then
            "g_in"
        else if (contains($rend-att, "qm_high")) then
            "qm_high"
        else if (contains($rend-att, "qm_low")) then
            "qm_low"
        else
            "g_in"
    let $mark-count :=
        if (contains($rend, "double")) then
            "double"
        else if (contains($rend, "single")) then
            "single"
        else if (contains($rend, "none")) then
            "none"
        else "double"
    let $mark-skip :=
        if (contains($rend, "no_opening")) then
            "no_opening"
        else if (contains($rend, "no_closing")) then
            "no_closing"
        else
            "none"
    let $opening-mark :=
        if ($mark-count = "none" or $mark-skip = "no_opening") then
            ""
        else
            $quote-marks($quote-mark)($mark-count)("open")
    let $closing-mark :=
        if ($mark-count = "none" or $mark-skip = "no_closing") then
            ""
        else
            $quote-marks($quote-mark)($mark-count)("close")
    return
        (map {
            "open": $opening-mark,
            "close": $closing-mark
        })
};

declare function kmg-util:resolve-project-id($project-id)
as node()? {
    let $text-id := tokenize($project-id, "-")[1]
    let $text-wit := tokenize($project-id, "-")[2]
    let $tg-uri := $kmg-util:Mapping//text[@kmg = $text-id]/@tguri/string()
    let $doc := doc($config:sade-data || $tg-uri || ".xml")
    let $wit :=
        if ($text-wit) then
            $doc//tei:sourceDesc//tei:witness[@xml:id = $text-wit]
        else
            $doc//tei:sourceDesc//tei:witness[tei:desc/@type[contains(., "Leittext")]]
    return
        $wit
};

declare function kmg-util:get-zotero-from-project-id($project-id)
as xs:string {
    let $wit := kmg-util:resolve-project-id($project-id)
    let $zotero-id :=
        if ($wit) then
            $wit//tei:bibl/@corresp/string()
        else
            ""
    return
        $zotero-id
};